
//pull location from our editEvent object
var location = editEvent.location;

//retrieve our canvas client object for authentication
var client = fbk.client();

//retrieve our canvas context object for REST links/urls
var context = fbk.context();

//retrieve the query URL from context
var url = context.links.queryUrl;

//SOQL Select Statement Fields;
var select = 'SELECT+Name,ShippingStreet,Phone,LastViewedDate+FROM+Account';

//SOQL Where Clause
var where = 'WHERE+ShippingCity+=+\'' + location + '\'';

//SOQL Order By Clause
var orderBy = 'ORDER+BY+Name';

//SOQL query
var query = select + '+' + where + '+' + orderBy;

//final URL for GET
var finalUrl = url + '?q=' + query;

//build settings object for Ajax call to Salesforce
var settings = {};
settings.client = client;
settings.contentType = 'application/json';
settings.success = processResult;

//Use canvas function to query
Sfdc.canvas.client.ajax ( finalUrl , settings );

//callback for ajax call
function processResult(data) {
  var result;
  if(data.status===200) {
    result = createString(data);
    //append to existing description
    editEvent.description += editEvent.description ? '\n' + result : result;
    //update popover angular timeout so it happens at the end of the digest cycle
    $timeout(function(){
      updateEvent(editEvent,null);
    },0);
    //put description text area in focus on timeout after the updateEvent
    $timeout(function(){
      $("[field=description]").focus();
      //put text area into focus.
    },100);
  }
  else {
    //error
  }
  //helper function to build string from result
  function createString(data) {
    var result = 'Salesforce Accounts In ' + location + '\n\n';
    if(data.payload.records.length) {
      for ( var i in data.payload.records) {
        result += 'Account Name: ' + data.payload.records[i].Name + '\n';
        result += 'Phone: ' + data.payload.records[i].Phone + '\n';
        result += 'Street :' + data.payload.records[i].ShippingStreet + '\n-\n';
      }
    }
    else {
      result += 'none';
    }
    return result;
  }
}
